//===----------------------------------------------------------------------===//
//
// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
// See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
//===----------------------------------------------------------------------===//

// test placement new

#include <new>
#include <cassert>

#include "test_macros.h"

int A_constructed = 0;

struct A
{
    A() {++A_constructed;}
    ~A() {--A_constructed;}
};

int main(int, char**)
{
    char buf[sizeof(A)];

    A* ap = new(buf) A;
    assert((char*)ap == buf);
    assert(A_constructed == 1);

  return 0;
}
